import numpy as np
import casadi as ca


a = np.array([75.0, 125.0, ...])
m = ...

b = np.array([80.0, ...])
n = ...

C = np.array([
        [...],
        [...],
        [...]
    ])

X = ca.MX.sym("X", m, n)

f = 0

for i in range(m):

    for j in range(n):

        f += C[...,...] * X[...,...]


g = []
g_min = []
g_max = []


for i in range(m):

    e = 0

    for j in range(n):

        e += X[...,...]

    g.append(e)
    g_min.append(a[i])
    g_max.append(a[i])


for j in range(n):

    e = 0

    for i in range(m):

        e += X[...,...]

    g.append(e)
    g_min.append(b[j])
    g_max.append(b[j])


g = ca.vertcat(*g)
X = ca.vec(X)

lp = {"x": X, "f": f, "g": g}

solver = ca.nlpsol("solver", "ipopt", lp)

X_init = np.zeros(X.shape)
X_min = np.zeros(X.shape)
X_max = np.inf * np.ones(X.shape)

solution = solver(x0 = X_init, lbx = X_min, ubx = X_max, \
    lbg = g_min, ubg = g_max)

K_opt = solution["f"]
X_opt = ca.reshape(solution["x"], 3, 4)

print "\nTransportation cost:\n\n" + str(K_opt)
print "\nTransportation matrix:\n" + str(X_opt)
